#include <stdio.h>
#include <ctype.h>

#include "lex.h"

/* lexical analysis routine
   returns LETTER for a lower case letter, *yylval = 0 through 25
   return DIGIT for a digit, *yylval = 0 through 9
   all other characters are returned immediately */
int calc_lex(calc_ctx_t *ctx, calc_STYPE *yylval)
{
	int c;
	while((c=getchar()) == ' ') ctx->col++; /* skip blanks */

	ctx->col++;

	if (c == '\n') {
		ctx->col = 0;
		ctx->line++;
	}

	yylval->line = ctx->line;
	yylval->col = ctx->col;

	/* c is now nonblank */
	if (islower(c)) {
		yylval->un = c - 'a';
		return LETTER;
	}
	if (isdigit(c)) {
		yylval->un = c - '0';
		return DIGIT;
	}
	return c;
}

