/* This file generated automatically using
 * 
 */

#include "defs.h"

/*  byaccic skel */
/*  If the skeleton is changed, the banner should be changed so that   */
/*  the altered version can be easily distinguished from the original. */
/*                                                                     */
/*  The #defines included with the banner are there because they are   */
/*  useful in subsequent code.  The macros #defined in the header or   */
/*  the body either are not useful outside of semantic actions or      */
/*  are conditional.                                                   */

const char *const banner[] =
{
    "",
"#ifdef YY_QUERY_API_VER"
,"#define YY_BYACCIC"
,    CONCAT1("#define YY_API_MAJOR ", YY_API_MAJOR),
    CONCAT1("#define YY_API_MINOR ", YY_API_MINOR),
"#endif /*YY_QUERY_API_VER*/",
    "",
    "#define `EMPTY`        (-1)",
    "#define `clearin`      (`chr` = `EMPTY`)",
    "#define `errok`        (`errflag` = 0)",
    "#define `RECOVERING`() (`errflag` != 0)",
    "#define `ENOMEM`       (-2)",
    "#define `EOF`          0",
    0
};

const char *const xdecls[] =
{
    0
};

const char *const tables[] =
{
    "`extern` `int_t` `lhs`[];",
    "`extern` `int_t` `len`[];",
    "`extern` `int_t` `defred`[];",
    "`extern` `int_t` `dgoto`[];",
    "`extern` `int_t` `sindex`[];",
    "`extern` `int_t` `rindex`[];",
    "`extern` `int_t` `gindex`[];",
    "`extern` `int_t` `table`[];",
    "`extern` `int_t` `check`[];",
    "",
    "#if `DEBUG` || defined(yytname)",
    "`extern` char *`name`[];",
    "#endif",
    "#if `DEBUG`",
    "`extern` char *`rule`[];",
    "#endif",
    0
};

const char *const global_vars[] =
{
    "",
    0
};

const char *const hdr_defs[] =
{
    "",
    "#ifndef `INITSTACKSIZE`",
    "#define `INITSTACKSIZE` 200",
    "#endif",
    "",
    "typedef struct {",
    "	unsigned stacksize;",
    "	`int_t` *s_base;",
    "	`int_t` *s_mark;",
    "	`int_t` *s_last;",
    "	`STYPE` *l_base;",
    "	`STYPE` *l_mark;",
    "#if `DEBUG`",
    "	int debug;",
    "#endif",
    "} `STACKDATA`;",
    "",
    "typedef struct {",
    "	int errflag;",
    "	int chr;",
    "	`STYPE` val;",
    "	`STYPE` lval;",
    "	int nerrs;",
    "	int yym, yyn, state;",
    "	int jump;",
    "	int stack_max_depth;",
    "	int debug;",
    "",
    "	/* variables for the parser stack */",
    "	`STACKDATA` stack;",
    "} `yyctx_t`;",
    "",
    "typedef enum { `RES_NEXT`, `RES_DONE`, `RES_ABORT` } `res_t`;",
    "",
    "`extern` int `parse_init`(`yyctx_t` *yyctx);",
    "`extern` `res_t` `parse`(`yyctx_t` *yyctx, `ctx_t` *ctx, int tok, `STYPE` *lval);",
    "`extern` void `error`(`ctx_t` *ctx, `STYPE` tok, const char *msg);",
    "",
    0
};

const char *const body_1[] =
{
    "",
    "#if `DEBUG`",
    "#include <stdio.h> /* needed for printf */",
    "#endif",
    "",
    "#include <stdlib.h> /* needed for malloc, etc */",
    "#include <string.h> /* needed for memset */",
    "",
    "/* allocate initial stack or double stack size, up to yyctx->stack_max_depth */",
    "static int `growstack`(`yyctx_t` *yyctx, `STACKDATA` *data)",
    "{",
    "	int i;",
    "	unsigned newsize;",
    "	`int_t` *newss;",
    "	`STYPE` *newvs;",
    "",
    "	if ((newsize = data->stacksize) == 0)",
    "		newsize = `INITSTACKSIZE`;",
    "	else if (newsize >= yyctx->stack_max_depth)",
    "		return `ENOMEM`;",
    "	else if ((newsize *= 2) > yyctx->stack_max_depth)",
    "		newsize = yyctx->stack_max_depth;",
    "",
    "	i = (int)(data->s_mark - data->s_base);",
    "	newss = (`int_t` *) realloc(data->s_base, newsize * sizeof(*newss));",
    "	if (newss == 0)",
    "		return `ENOMEM`;",
    "",
    "	data->s_base = newss;",
    "	data->s_mark = newss + i;",
    "",
    "	newvs = (`STYPE` *) realloc(data->l_base, newsize * sizeof(*newvs));",
    "	if (newvs == 0)",
    "		return `ENOMEM`;",
    "",
    "	data->l_base = newvs;",
    "	data->l_mark = newvs + i;",
    "",
    "	data->stacksize = newsize;",
    "	data->s_last = data->s_base + newsize - 1;",
    "	return 0;",
    "}",
    "",
    "static void `freestack`(`STACKDATA` *data)",
    "{",
    "	free(data->s_base);",
    "	free(data->l_base);",
    "	memset(data, 0, sizeof(*data));",
    "}",
    "",
    "#define `ABORT`  goto yyabort",
    "#define `REJECT` goto yyabort",
    "#define `ACCEPT` goto yyaccept",
    "#define `ERROR`  goto yyerrlab",
    "",
    "int `parse_init`(`yyctx_t` *yyctx)",
    "{",
    "#if `DEBUG`",
    "	const char *yys;",
    "",
    "	if ((yys = getenv(\"`DEBUG`\")) != 0) {",
    "		`yyn` = *yys;",
    "		if (`yyn` >= '0' && `yyn` <= '9')",
    "			`debug` = `yyn` - '0';",
    "	}",
    "#endif",
    "",
    "	memset(&`val`, 0, sizeof(`val`));",
    "	memset(&`lval`, 0, sizeof(`lval`));",
    "",
    "	`yym` = 0;",
    "	`yyn` = 0;",
    "	`nerrs` = 0;",
    "	`errflag` = 0;",
    "	`chr` = `EMPTY`;",
    "	`state` = 0;",
    "",
    "	memset(&`stack`, 0, sizeof(`stack`));",
    "",
    "	yyctx->stack_max_depth = `INITSTACKSIZE` > 10000 ? `INITSTACKSIZE` : 10000;",
    "	if (`stack`.s_base == NULL && `growstack`(yyctx, &`stack`) == `ENOMEM`)",
    "		return -1;",
    "	`stack`.s_mark = `stack`.s_base;",
    "	`stack`.l_mark = `stack`.l_base;",
    "	`state` = 0;",
    "	*`stack`.s_mark = 0;",
    "	`jump` = 0;",
    "	return 0;",
    "}",
    "",
    "",
    "#define `GETCHAR`(labidx) \\",
    "do { \\",
    "	if (used)               { `jump` = labidx; return `RES_NEXT`; } \\",
    "	getchar_ ## labidx:;    `chr` = tok; `lval` = *lval; used = 1; \\",
    "} while(0)",
    "",
    "`res_t` `parse`(`yyctx_t` *yyctx, `ctx_t` *ctx, int tok, `STYPE` *lval)",
    "{",
    "	int used = 0;",
    "#if `DEBUG`",
    "	const char *yys;",
    "#endif",
    "",
    0
};

const char *const body_3[] =
{
    "yyloop:;",
    "	if (`jump` == 1) { `jump` = 0; goto getchar_1; }",
    "	if (`jump` == 2) { `jump` = 0; goto getchar_2; }",
    "",
    "	if ((`yyn` = `defred`[`state`]) != 0)",
    "		goto yyreduce;",
    "	if (`chr` < 0) {",
    "		`GETCHAR`(1);",
    "		if (`chr` < 0)",
    "			`chr` = `EOF`;",
    "#if `DEBUG`",
    "		if (`debug`) {",
    "			if ((yys = `name`[`TRANSLATE`(`chr`)]) == NULL)",
    "				yys = `name`[`UNDFTOKEN`];",
    "			printf(\"`debug`: state %d, reading %d (%s)\\n\", `state`, `chr`, yys);",
    "		}",
    "#endif",
    "	}",
    "	if (((`yyn` = `sindex`[`state`]) != 0) && (`yyn` += `chr`) >= 0 && `yyn` <= `TABLESIZE` && `check`[`yyn`] == (`int_t`) `chr`) {",
    "#if `DEBUG`",
    "		if (`debug`)",
    "			printf(\"`debug`: state %d, shifting to state %d\\n\", `state`, `table`[`yyn`]);",
    "#endif",
    "		if (`stack`.s_mark >= `stack`.s_last && `growstack`(yyctx, &`stack`) == `ENOMEM`)",
    "			goto yyoverflow;",
    "		`state` = `table`[`yyn`];",
    "		*++`stack`.s_mark = `table`[`yyn`];",
    "		*++`stack`.l_mark = `lval`;",
    "		`chr` = `EMPTY`;",
    "		if (`errflag` > 0)",
    "			--`errflag`;",
    "		goto yyloop;",
    "	}",
    "	if (((`yyn` = `rindex`[`state`]) != 0) && (`yyn` += `chr`) >= 0 && `yyn` <= `TABLESIZE` && `check`[`yyn`] == (`int_t`) `chr`) {",
    "		`yyn` = `table`[`yyn`];",
    "		goto yyreduce;",
    "	}",
    "	if (`errflag` != 0)",
    "		goto yyinrecovery;",
    "",
    "	`error`(ctx, `lval`, \"syntax error\");",
    "",
    "	goto yyerrlab;	/* redundant goto avoids 'unused label' warning */",
    "yyerrlab:",
    "	++`nerrs`;",
    "",
    "yyinrecovery:",
    "	if (`errflag` < 3) {",
    "		`errflag` = 3;",
    "		for(;;) {",
    "			if (((`yyn` = `sindex`[*`stack`.s_mark]) != 0) && (`yyn` += `ERRCODE`) >= 0 && `yyn` <= `TABLESIZE` && `check`[`yyn`] == (`int_t`) `ERRCODE`) {",
    "#if `DEBUG`",
    "				if (`debug`)",
    "					printf(\"`debug`: state %d, error recovery shifting to state %d\\n\", *`stack`.s_mark, `table`[`yyn`]);",
    "#endif",
    "				if (`stack`.s_mark >= `stack`.s_last && `growstack`(yyctx, &`stack`) == `ENOMEM`)",
    "					goto yyoverflow;",
    "				`state` = `table`[`yyn`];",
    "				*++`stack`.s_mark = `table`[`yyn`];",
    "				*++`stack`.l_mark = `lval`;",
    "				goto yyloop;",
    "			}",
    "			else {",
    "#if `DEBUG`",
    "				if (`debug`)",
    "					printf(\"`debug`: error recovery discarding state %d\\n\", *`stack`.s_mark);",
    "#endif",
    "				if (`stack`.s_mark <= `stack`.s_base)",
    "					goto yyabort;",
    "				--`stack`.s_mark;",
    "				--`stack`.l_mark;",
    "			}",
    "		}",
    "	}",
    "	else {",
    "		if (`chr` == `EOF`)",
    "			goto yyabort;",
    "#if `DEBUG`",
    "		if (`debug`) {",
    "			if ((yys = `name`[`TRANSLATE`(`chr`)]) == NULL)",
    "				yys = `name`[`UNDFTOKEN`];",
    "			printf(\"`debug`: state %d, error recovery discards token %d (%s)\\n\", `state`, `chr`, yys);",
    "		}",
    "#endif",
    "		`chr` = `EMPTY`;",
    "		goto yyloop;",
    "	}",
    "",
    "yyreduce:",
    "#if `DEBUG`",
    "	if (`debug`)",
    "		printf(\"`debug`: state %d, reducing by rule %d (%s)\\n\", `state`, `yyn`, `rule`[`yyn`]);",
    "#endif",
    "	`yym` = `len`[`yyn`];",
    "	if (`yym` > 0)",
    "		`val` = `stack`.l_mark[1 - `yym`];",
    "	else",
    "		memset(&`val`, 0, sizeof `val`);",
    "",
    "	switch (`yyn`) {",
    0
};

const char *const trailer[] =
{
    "	}",
    "	`stack`.s_mark -= `yym`;",
    "	`state` = *`stack`.s_mark;",
    "	`stack`.l_mark -= `yym`;",
    "	`yym` = `lhs`[`yyn`];",
    "	if (`state` == 0 && `yym` == 0) {",
    "#if `DEBUG`",
    "		if (`debug`)",
    "			printf(\"`debug`: after reduction, shifting from state 0 to state %d\\n\", `FINAL`);",
    "#endif",
    "		`state` = `FINAL`;",
    "		*++`stack`.s_mark = `FINAL`;",
    "		*++`stack`.l_mark = `val`;",
    "		if (`chr` < 0) {",
    "			`GETCHAR`(2);",
    "			if (`chr` < 0)",
    "				`chr` = `EOF`;",
    "#if `DEBUG`",
    "			if (`debug`) {",
    "				if ((yys = `name`[`TRANSLATE`(`chr`)]) == NULL)",
    "					yys = `name`[`UNDFTOKEN`];",
    "				printf(\"`debug`: state %d, reading %d (%s)\\n\", `FINAL`, `chr`, yys);",
    "			}",
    "#endif",
    "		}",
    "		if (`chr` == `EOF`)",
    "			goto yyaccept;",
    "		goto yyloop;",
    "	}",
    "	if (((`yyn` = `gindex`[`yym`]) != 0) && (`yyn` += `state`) >= 0 && `yyn` <= `TABLESIZE` && `check`[`yyn`] == (`int_t`) `state`)",
    "		`state` = `table`[`yyn`];",
    "	else",
    "		`state` = `dgoto`[`yym`];",
    "#if `DEBUG`",
    "	if (`debug`)",
    "		printf(\"`debug`: after reduction, shifting from state %d to state %d\\n\", *`stack`.s_mark, `state`);",
    "#endif",
    "	if (`stack`.s_mark >= `stack`.s_last && `growstack`(yyctx, &`stack`) == `ENOMEM`)",
    "		goto yyoverflow;",
    "	*++`stack`.s_mark = (`int_t`) `state`;",
    "	*++`stack`.l_mark = `val`;",
    "	goto yyloop;",
    "",
    "yyoverflow:",
    "	`error`(ctx, `lval`, \"yacc stack overflow\");",
    "",
    "yyabort:",
    "	`freestack`(&`stack`);",
    "	return `RES_ABORT`;",
    "",
    "yyaccept:",
    "	`freestack`(&`stack`);",
    "	return `RES_DONE`;",
    "}",
    0
};

void puts_code(FILE *fp, const char *s);
void putc_code(FILE * fp, int c);
void
write_section(FILE * fp, const char *const section[])
{
    int i;
    const char *s;

    for (i = 0; (s = section[i]) != 0; ++i)
    {
	puts_code(fp, s);putc_code(fp, '\n');
    }
}
